/******************************************************************************
 *  Author:		Joey Richey (CM 1698)                                         *
 *  Project:	Maze Generator                                                *
 *	Filename:	solveMaze.h												      *
 *                                                                            *
 *	header file for the function/class solveMazee. it either creates a header *
 *	file or a class header file, depending on the build enviorment. Its       *
 *	purpose is described in the cpp file.                                     *
 *                                                                            *
 *****************************************************************************/

#ifndef _SOLVEMAZE_H
#define _SOLVEMAZE_H

/*===============================
	class/function solveMaze	
===============================*/

#include "defines.h"
#include <stack>		/*	used to keep track of how to get to end of 
							the maze	*/
#include <stdio.h>
#include <stdlib.h>

#ifdef USE_ZTHREAD
class solveMaze : public Runnable
{
public:

	void run(void);
#else	/*	USE_ZTHREAD	*/

	/*	if i am using pthreads/no threads, i have to make solveMaze into a 
		function and not a class, so a little confusing code, but it gives 
		the class or the function the same name, which I can call in code	*/
	void * solveMaze(void *);
#endif

#ifdef USE_ZTHREAD
private:
#endif
	/*	helper procedure to solve the maze	*/
	void mazeSolveHelper(int, int, int);
	bool wallExist(int, int, int, int);	/*	returns if a wall does exists
											between the two cells	*/
#ifdef USE_ZTHREAD
	int	**solveData;	/*	will be a two dimensional array for each cell and
							will hold -1 if recusion has not been there,
							previous best number of moves to get there 
							otherwise	*/

	std::stack<int> solve;	/*	a stack that hold the cell numberof everywhere
								we	have been	*/

};	/*	end of class solveMaze	*/

#endif	/*	USE_ZTHREAD	*/


#endif