/******************************************************************************
 *  Author:		Joey Richey (CM 1698)                                         *
 *  Project:	Maze Generator                                                *
 *	Filename:	union.cpp  												      *
 *                                                                            *
 *	this is an implementation of a Union/set class described in the java book *
 *	and needed for the maze algorithim to work. It is not complete or very	  *
 *  efficent, but it does get the job done. The error checking also isn't     *
 *  extraordinary, so only pass good values                                   *
 *                                                                            *
 *****************************************************************************/


#include "union.h"

/*	construction	*/
Union::Union(int i)
{
	index = (int *) calloc(i,sizeof(int));
	if (index == NULL)
		fatalError(UNION_INIT);

	curIndex=0;
	curUnionID=0;
	maxItems = i;
}

/*	deconstructor	*/
Union::~Union()
{
	free(index);
}

int Union::Create(int i)
{
	if (i >= maxItems)
		return -1;
	index[curIndex++]=curUnionID++;
	return curUnionID;
}

bool Union::Matches(int i, int j)
{
	if ((i > maxItems) || (j > maxItems))
		fatalError(UNION_MATCH_OUT_OF_BOUNDS);
		

	
	if (index[i] == index[j])
	{
#ifdef UNION_DEBUG
		printf("UNION::Items (%d, %d) do match, unionID: %d\n",i,j,index[i]);
#endif
		return true;
	}
	else
	{
#ifdef UNION_DEBUG
		printf("UNION::Items (%d, %d) do not match, unionID: (%d, %d)\n",
				i,j,index[i],index[j]);
#endif

		return false;
	}
}

int Union::Merge(int i, int j)
{

	int loopindex;

	int searchFor = index[i];
	if ((i > maxItems) || (j > maxItems))
		fatalError(UNION_MERGE_OUT_OF_BOUNDS);

	for(loopindex=0;loopindex<curIndex;loopindex++)
	{
		if(index[loopindex] == searchFor)
		{
#ifndef UNION_DEBUG
			index[loopindex]=index[j];	
#else
			printf("UNION::moved item with value %d and old UnionID %d into \
					unionID %d\n",loopindex,index[loopindex],index[j]);
			index[loopindex]=index[j];
		}
		else
		{
			printf("UNION::MOVE-not moved item with value %d unionid: %d\n",
					loopindex,index[loopindex]);
#endif
		}
	}



	return index[i];
}



#ifdef UNION_DEBUG
void Union::PrintDebug(void)
{
	int i,j;
	bool printedStart = false;
	for (i=0;i<curUnionID;i++)
	{
		
		for(j=0;j<curIndex;j++)
		{
			if(i == index[j])
			{
				if (printedStart == false)
				{
					printedStart = true;
					printf("([%d]-",i);
				}
				printf("%d,",j);
			}
		}
		if (printedStart == true)
			printf(")");
		printedStart = false;
	}
	printf("\n");

}
#endif