/******************************************************************************
 *  Author:		Joey Richey (CM 1698)                                         *
 *  Project:	Maze Generator                                                *
 *	Filename:	union.h  												      *
 *                                                                            *
 *	this is header file for an implementation of a Union/set class described  *
 *  in the java book, "Data Structres & Problem Solving Using Java" by Mark   *
 *	Weiss on pages 803-806. more info about this class included in the cp file*
 *                                                                            *
 *****************************************************************************/

#ifndef UNION_H
#define UNION_H

/*	enable/disable debug messages	*/
//#define UNION_DEBUG 1

#include "defines.h"
#include <stdlib.h>

#ifdef UNION_DEBUG
	#include <stdio.h>
#endif

class Union  
{
	public:
		/*	constructor (no default one). takes the maxium number of elements
			the Union will have	*/
		Union(int);

		/*	deconstructor to free alocated memeory	*/
		virtual ~Union();


		/* merges the two unions that contain [1] and [2]	*/
		int Merge(int,int);

		/*	returns true if [1] and [2] are in the same union, false 
			if they are not	*/
		bool Matches(int, int);

		/*	creates a new union with [1] in it, returns the unionID if 
			successful, -1 otherwise	*/
		int Create(int);

#ifdef UNION_DEBUG
		/*	prints out the current state of the Union	*/
		void PrintDebug(void);
#endif

	private:
		int curIndex;	/*	the last index that hasn't been used	*/
		int curUnionID;	/*	the value of the next Union Id to use	*/
		int *index;		/*	holds the data for the union in an array	*/
		int maxItems;	/*	the max number of items the union can hold	*/
};

#endif